using System;
using System.Collections.Generic;
using System.Text;

namespace CornerCrash
{
    class CharTypeDispString
    {
        public static CharTypeDispString instance;
        
        private string[] charTypeStrings = {
            "",
            "vC[",
            "̎qP",
            "̎qQ",
            "f",
            "ق",
            "",
            "x@",
            "ŏI",
            //"TypeEnd", enum`̑̂̒萔̒lcharTypeStrings̗vfƈvdlƂB
        };

        private CharTypeDispString()
        {

        }

        public static CharTypeDispString getinstance()
        {
            if (instance != null)
            {
                return instance;
            }
            instance = new CharTypeDispString();
            return instance;
        }
        
        public int Length
        {
            get
            {
                return charTypeStrings.Length;
            }
        }

        public string this[string key]
        {
            get
            {
                CharTypeString chartypetable = CharTypeString.getinstance();
                for (int i = 0; i < chartypetable.Length; i++)
                {
                    if (chartypetable[i] == key)
                    {
                       return this[i];
                    }
                }
                throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                    "L[̒lsłB");
            }
        }

        public string this[int i]
        {
            get
            {
                return charTypeStrings[i];
            }
        }
    }
}
