using System;
using System.Collections.Generic;
using System.Text;

namespace CornerCrash
{
    class DataRecord : IDisposable

    {
        Dictionary<string, string> rec;
        
        public DataRecord()
        {
            rec = new Dictionary<string, string>();
        }

        public string this[string key]
        {
            set
            {
                rec[key] = value;
            }

            get
            {
                return rec[key];
            }
        }

        public object this[string key, TypeCode type]
        {
            get
            {
                if (type == TypeCode.Int32)
                {
                    return int.Parse(rec[key]);
                }

                else if (type == TypeCode.String)
                {
                    return rec[key];
                }
                else
                {
                    throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                        "rec ̕ϊ̌^w肪sł : ^ : " + type.GetType());
                }
            }

            set
            {
                if (type == TypeCode.Int32)
                {
                    rec[key] = value.ToString();
                }

                else if (type == TypeCode.String)
                {
                    rec[key] = (string)value;
                }

                else
                {
                    throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                        "rec ֑ľ^sł : ^ : " + type.GetType());
                }
            }
        }

        public List<string> defkeys
        {
            get
            {
                List<string> retkeys = new List<string>();
                foreach (KeyValuePair<string, string> retkey in rec)
                {
                    retkeys.Add(retkey.Key);
                }
                return retkeys;
            }
        }

        public virtual void Dispose()
        {
            if (rec != null)
            {
                rec.Clear();
            }
            rec = null;
        }
    }
}
