using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace CornerCrash
{
    class Debug
    {
        private static bool logenable = true;

        public static void LOGPRINT(object classname, MethodBase func, string message)
        {
            if (logenable == false)
            {
                return;
            }

            System.Console.WriteLine("class : " + classname.GetType().ToString() + "\nfunction : " + func.Name +
             "\n" + message);
        }

        public static void LOGPRINT(object parentclass, object classname, string func, string message)
        {
            if (logenable == false)
            {
                return;
            }

            System.Console.WriteLine("parentclass : " + parentclass.GetType().ToString() + 
                " class : " + classname.GetType().ToString() + "\nfunction : " + func +
             "\n" + message);
        }
    }
}
