using System;
using System.Collections.Generic;
using System.Text;

namespace CornerCrash
{
    class EvtConditionTbl : DataTable
    {
        int recpt;

        public const string stageid = "stageid";
        public const string eventid = "eventid";
        public const string enable = "enable";
        public const string time = "time";
        public const string random = "random";
        public const string upflagsid = "upflags";
        public const string downflagsid = "downflags";
        public const string execevent = "execevent";
        public const string nextevtid = "nextevtid";
        public const string mapx = "mapx";
        public const string mapy = "mapy";

        public EvtConditionTbl()
            : base()
        {
            recpt = 0;
        }

        public override void ReadCsv(string filename)
        {
            base.ReadCsv(filename);
            //if (table.Count < 1)
            //{
                //throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(), 
                //    "Cxge[uɗLȃR[h܂B");
            //}
        }
        public DataRecord getFirstRecord(int stage)
        {
            int i;
            for (i = 0; i < table.Count; i++)
            {
                if ((int)this[i, stageid, TypeCode.Int32] == stage)
                {
                    break;
                }
            }
            if (i == table.Count)
            {
//                throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
//                    "Cxge[uɃXe[WID " + stage + " ܂B");
                return null;
            }
            recpt = i+1;
            return table[i];
        }

        public DataRecord getNextRecord(int stage)
        {
            int i;
            for (i = recpt; i < table.Count; i++)
            {
                if ((int)this[i, stageid, TypeCode.Int32] == stage)
                {
                    break;
                }
            }
            if (i == table.Count)
            {
                return null;
            }
            recpt = i+1;
            return table[i];
        }
    }
}
