using Sys = System;
using System.Collections.Generic;
using System.Text;
using CornerCrash;

namespace Yanesdk.System
{
    class FileArchiverRootZip : FileArchiverZip
    {
        string zipfile;
        
        public FileArchiverRootZip()
        {
            throw new CornerCrashException(this, Sys.Reflection.MethodBase.GetCurrentMethod(),
                "FileArchiverRootZip()͎gpł܂BFileArchiverRootZip(string filename)" +
                "FileArchiverRootZip(string filename, IFileReader reader)gpĂB");
        }

        public FileArchiverRootZip(IFileReader reader)
        {
            throw new CornerCrashException(this, Sys.Reflection.MethodBase.GetCurrentMethod(),
                "FileArchiverRootZip(IFileReader reader)͎gpł܂BFileArchiverRootZip(string filename)" +
                "FileArchiverRootZip(string filename, IFileReader reader)gpĂB");
        }

        public FileArchiverRootZip(string filename) : base()
        {
            zipfile = filename;
        }

        public FileArchiverRootZip(string filename, IFileReader reader) : base(reader)
        {
            zipfile = filename;
        }

        public override bool IsExist(string filename)
        {
            filename = FileSys.ConcatPath(zipfile, filename);
            return base.IsExist(filename);
        }

        public override byte[] Read(string filename)
        {
            filename = FileSys.ConcatPath(zipfile, filename);
            return base.Read(filename);
        }
    }
}
