using System;
using System.Collections.Generic;
using System.Text;

namespace CornerCrash
{
    class GameState
    {
        protected static GameState instance;

        public enum Mode
        {
            TITLE,
            MAIN,
            EVENT,
            STAGEEND,
            CLEAR,
            SHORTSTORY,
            NEXTSTAGE,
            GAMEOVER,
            GAMECLEAR,
            ENDING,
            STGSTART,
        }

        public int stage;

        Mode mode;

        protected GameState()
        {
            //mode = Mode.TITLE;//^Cgʂꍇɕς邩H
            mode = Mode.MAIN;
            stage = 0;
        }

        public static GameState getInstance()
        {
            if (instance != null)
            {
                return instance;
            }

            instance = new GameState();

            return instance;
        }

        public Mode State
        {
            get
            {
                return mode;
            }

            set
            {
                mode = value;
            }
        }
    }
}
