using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using Yanesdk.System;

namespace CornerCrash
{
    class LimitTimes : IDisposable
    {
        List<int> times;
        static LimitTimes instance;
        private int curtime;
        private string conffile;

        private LimitTimes()
        {
            times = new List<int>();
            curtime = 0;
            conffile = "";
        }

        public static LimitTimes getInstance()
        {
            if (instance == null)
            {
                throw new CornerCrashException(ClassName, System.Reflection.MethodBase.GetCurrentMethod(),
                    "t@Cǂݍ܂Ă܂B");
            }

            return instance;
        }

        public static LimitTimes getInstance(string filename)
        {
            //CX^XAђ`t@CύX݂̂ĂԂƁB
            //ς݃CX^X̎擾݂̂sꍇ́AȂgetInstance()ĂԂƁB
            if (instance != null)
            {
                if (instance.conffile == filename)
                {
                    throw new CornerCrashException(instance, System.Reflection.MethodBase.GetCurrentMethod(),
                        "`t@C" + "(t@CF" + instance.conffile + ")CX^X𐶐ς݂łB");
                }
                instance.Dispose();
            }

            instance = new LimitTimes();

            if (Util.IsExist(filename) == false)
            {
                throw new FileNotFoundException("w肵t@C܂B", filename);
            }

            byte[] buff = null;

            buff = FileSys.Read(filename);

            string[] timesstrs = Util.CnvByteArrayToStr(buff).Split("\n".ToCharArray());

            foreach (string timestr in timesstrs)
            {
                if (timestr == "")
                {
                    break;
                }
                instance.times.Add(Int32.Parse(timestr));
            }

            return instance;
        }

        public int this[int i]
        {
            get
            {
                if (((i >= 0) && (i < times.Count)) == false)
                {
                    throw new CornerCrashException(this, System.Reflection.MethodBase.GetCurrentMethod(),
                        "Ԓ`Xg̃CfbNX͈͊OłB");
                }

                return times[i];
            }
        }

        public void InitCurTime(int index)
        {
            curtime = times[index];
        }

        public void DecCurTime()
        {
            curtime--;
            if (curtime < 0)
            {
                curtime = 0;
            }
        }

        public void DecCurTime(int time)
        {
            curtime -= time;
            if (curtime < 0)
            {
                curtime = 0;            }

        }

        public int CurTime
        {
            get
            {
                return curtime;
            }
        }

        public static string ClassName
        {
            get
            {
                return "LimitTimes";
            }
        }

        public int Length
        {
            get
            {
                return times.Count;
            }
        }

        public void Dispose()
        {
            times.Clear();
        }
    }
}
