using System;
using System.Collections.Generic;
using System.Text;
using YD = Yanesdk.Draw;

namespace CornerCrash
{
    class TestModule
    {
        YD.GlTexture texture;
        YD.Screen2DGl screen;

        BaseSprite sprite;
        int mx, my;

        public TestModule(YD.Screen2DGl prmscreen)
        {
            screen = prmscreen;
            mx = 2;
            my = 2;
        }

        public void LoadSprite()
        {
            texture = new Yanesdk.Draw.GlTexture();
            texture.Load("test.gif");

            sprite = new BaseSprite(screen, texture);
        }

        public void moveSprite()
        {
            if( (sprite.x + mx + sprite.width) > CornerCrashDefine.WINDOW_WIDTH)
            {
                sprite.x = (CornerCrashDefine.WINDOW_WIDTH - sprite.width);
                mx = -mx;
            }
            else if (sprite.x + mx < 0)
            {
                sprite.x = 0;
                mx = -mx;
            }

            if ((sprite.y + my + sprite.height) > CornerCrashDefine.WINDOW_HEIGHT)
            {
                sprite.y = (CornerCrashDefine.WINDOW_HEIGHT - sprite.height);
                my = -my;
            }
            else if(sprite.y + my < 0)
            {
                sprite.y = 0;
                my = -my;
            }

            sprite.Move(mx, my);

        }
    }
}
