using System;
using System.Collections.Generic;
using System.Text;
using Yanesdk.System;
using Yanesdk.Ytl;

namespace CornerCrash
{
    class CSVReaderEx
    {
        #region eXgp̃R[h
        //tB[h̉sɑΉ邽߂ɁA
        //CSVReaderRead\bĥ݂ւNX`B
        //pgȂ̂́AprivateoɌpNX̓ANZXsȊ֌WB
        #endregion

        protected bool isDoubleQuote = false;

        protected bool BOMFound = false;

        /// <summary>
        /// CSVt@Cf[^ǂݍ
        /// </summary>
        ///	<example>
        /// CSVReader reader = new CSVReader();
        ///	reader.read("csv.txt");
        ///	reader.DebugOutput();
        /// </example>
        /// <param name="filename"></param>
        /// <returns></returns>
        public YanesdkResult Read(string filename)
        {
            csvdata.Clear();

            byte[] data = FileSys.Read(filename);
            if (data == null)
                return YanesdkResult.FileReadError;

            BOMFound = (data.Length >= 2 &&
                data[0] == 0xff &&
                data[1] == 0xfe);

            isDoubleQuote = false;
            // data͂ĂB
            StringBuilderEncoding line = new StringBuilderEncoding();

            if (BOMFound)
            {
                for (int i = 2; i < data.Length; )
                {
                    byte b1 = data[i++];
                    if (!(i < data.Length)) break;
                    byte b2 = data[i++];

                    if ((b1 == '"') && (b2 == '"'))
                    {
                        line.Add(b1);
                        b1 = b2;
                        if (!(i < data.Length)) break;
                        b2 = data[i];
                        i++;
                    }
                    else if (b1 == '"')
                    {
                        line.Add(b1);
                        b1 = b2;
                        if (!(i < data.Length))
                        {
                            isDoubleQuote = false;
                            break;
                        }

                        b2 = data[i];
                        i++;

                        if (isDoubleQuote == false)
                        {
                            isDoubleQuote = true;
                        }
                        else
                        {
                            isDoubleQuote = false;
                        }
                    }

                    if ((b2 == 0 && (b1 == 0x0a || b1 == 0x0d)) && isDoubleQuote == false)
                    {
                        // sǂ߂̂line
                        Parse(line, BOMFound);
                        line.Clear();
                    }
                    else
                    {
                        line.Add(b1);
                        line.Add(b2);
                    }
                }
            }
            else
            {
                for (int i = 0; i < data.Length; )
                {
                    byte b1 = data[i++];
                    if (!(i < data.Length)) break;
                    byte b2 = data[i];

                    if ((b1 == '"') && (b2 == '"'))
                    {
                        line.Add(b1);
                        b1 = data[i++];
                    }
                    else if (b1 == '"')
                    {
                        line.Add(b1);
                        b1 = data[i++];

                        if (isDoubleQuote == false)
                        {
                            isDoubleQuote = true;
                        }
                        else
                        {
                            isDoubleQuote = false;
                        }
                    }

                    if ((b1 == 0x0a || b1 == 0x0d) && isDoubleQuote == false)
                    {
                        // sǂ߂̂line
                        Parse(line, BOMFound);
                        line.Clear();
                    }
                    else
                    {
                        line.Add(b1);
                    }
                }
            }
            // ŌɉsȂline\A
            if (line.Count != 0) Parse(line, BOMFound);

            return YanesdkResult.NoError;
        }

        /// <summary>
        /// ̃NXŎgR[hy[Ww肷B
        /// xݒ肷ƍēxݒ肷܂ŗLB
        /// fBtHgł́AShift_JISB
        /// BOMtutf-16łǂݍ߂B
        /// </summary>
        public global::System.Text.Encoding CodePage
        {
            get { return codePage; }
            set { codePage = value; }
        }
        protected global::System.Text.Encoding codePage = Encoding.GetEncoding("Shift_JIS");

        /// <summary>
        /// s͂
        /// </summary>
        /// <remarks>
        /// s̉͂̂Ƃ
        ///		1,2,3 // Rg
        /// @@@@@̂悤ȏ\B𐳂͂̂
        ///		@@@\ʓ|ǑΉ邱ƂɂB
        /// </remarks>
        /// <param name="line"></param>
        protected void Parse(StringBuilderEncoding bytes, bool BOMFound)
        {
            string line;
            if (BOMFound)
            {
                line = bytes.Convert(Encoding.GetEncoding("utf-16"));
            }
            else
            {
                line = bytes.Convert(codePage);
            }
            List<string> list = new List<string>();
            StringBuilder atom = new StringBuilder();

            // end of linetO
            bool eol = false;

            // sł͂Ȃ̂
            bool valid = false;

            char c = default(char);
            // warningoƌȂ̂(L`)
            isDoubleQuote = false;
            //_uNI[e[VΉ
            for (int i = 0; i < line.Length + 1; ++i)
            {
                if (i < line.Length)
                    c = line[i];
                else
                    eol = true;

                if (c == '"')
                {
                    if (i == line.Length)
                    {
                        eol = true;
                        isDoubleQuote = false;
                    }
                    else
                    {
                        c = line[++i];
                        if (c != '"' && (isDoubleQuote == false))
                        {
                            isDoubleQuote = true;
                        }
                        else if (c != '"')
                        {
                            isDoubleQuote = false;
                        }
                        else
                        {
                            atom.Append('"');
                            continue;
                        }
                    }        
                }

                if (i == line.Length)
                {
                    isDoubleQuote = false;
                    eol = true;
                }
                //  "//"Ŏn܂ׂ̂邽߂ɁA'/'ł
                // ꕶǂ݂Ă炤B
                //if (c == '/' && i < line.Length - 1 && line[i + 1] == '/')
                // {
                    // ȍ~̓RgȂ̂ŁAJ}ɑƂΗǂB
                    //eol = true;
                //}
                //ExcelŃtB[h"//"݂̂͂ƂAɃGXP[vꂸA
                //_uNI[e[Vł͂܂Ȃ߁AG[̂߃RgAEg
                if (!eol)
                {
                    // ڐ擪space͖
                    if (atom.Length == 0 && c == ' ')
                        continue;

                    // ړrł TAB ͏ɂ疳
                    if (c == '\t')
                        continue;
                }

                bool comma = c == ',';

                // łJ}΂͈Ӗ̂sƂ݂Ȃ
                if (comma)
                    valid = true;

                if ((comma || eol) && (isDoubleQuote == false)) 
                {
                    //J}؂ ""ݒ肷邱Ƃ̂ł̃`FbNsvB
                    //	if (atom.Length!=0)

                    // space͍폜B
                    while (0 < atom.Length
                        && atom[atom.Length - 1] == ' ')
                        --atom.Length;

                    list.Add(atom.ToString());

                    // ЂƂłLȗvfΗLȍsł
                    if (atom.Length != 0)
                        valid = true;

                    atom.Length = 0;

                    if (eol)
                        break; // for甲

                    continue;
                }

                atom.Append(c);
            }

            if (valid)
                csvdata.Add(list);
        }

        /// <summary>
        /// ǂݍ񂾃f[^擾B
        /// </summary>
        /// <remarks>
        /// ǂݍ݂ɎsĂ߂lnullł͂ȂƂ͕ۏ؂B
        /// </remarks>
        public List<List<string>> CsvData { get { return csvdata; } }

        /// <summary>
        /// Debugpɓǂݍ񂾃f[^Consoleɕ\
        /// </summary>
        public void DebugOutput()
        {
            foreach (List<string> line in csvdata)
            {
                bool first = true;
                foreach (string s in line)
                {
                    // 擪ȊOɂ̓J}
                    if (!first)
                        global::System.Console.Write(',');

                    first = false;
                    global::System.Console.Write(s);
                }
                global::System.Console.WriteLine();
            }

        }

        protected List<List<string>> csvdata = new List<List<string>>();
    }
}
