using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace CornerCrash
{
    class CornerCrashException : Exception
    {
        public CornerCrashException(string message)
            : base(message)
        {

        }
        public CornerCrashException(object classname, MethodBase func, string message)
            : base("class : " + classname.GetType().ToString() + "\nfunction : " + func.Name + 
             "\n" + message)
        {

        }

        public CornerCrashException(string classname, MethodBase func, string message)
            : base("class : " + classname + "\nfunction : " + func.Name +
             "\n" + message)
        {

        }
    }
}
