using System;
using System.Collections.Generic;
using System.Text;
using Yanesdk.System;

namespace CornerCrash
{
    class FileArchiverSingleton
    {
        FileArchiverZip val;
        static FileArchiverSingleton instance;

        private FileArchiverSingleton()
        {

        }

        public static FileArchiverSingleton getInstance()
        {
            if(instance != null)
            {
                return instance;
            }

            instance = new FileArchiverSingleton();

            return instance;
        }

        public FileArchiverZip Archiver
        {
            get
            {
                return val;
            }
            set
            {
                val = value;
            }
        }
    }
}
