using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace CornerCrash
{
    class FormInfo
    {
        protected Form val;
        protected static FormInfo instance;

        private FormInfo()
        {

        }

        public static FormInfo getInstance()
        {
            if (instance != null)
            {
                return instance;
            }

            instance = new FormInfo();

            return instance;
        }

        public void Set(Form form)
        {
            val = form;
        }

        public Form Get()
        {
            return val;
        }

        public bool IsActive
        {
            get
            {
                if (val == null)
                {
                    return false;
                }

                return (Form.ActiveForm == val);
            }
        }
    }
}
